; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    dim$ MACRO member_count
      invoke create_string_array,member_count
      EXITM <eax>
    ENDM

    erase$ MACRO arr
      invoke delete_string_array,arr
      EXITM <eax>
    ENDM

    arrset$ MACRO arr,indx,ptxt
      invoke write2_string_array,arr,indx,reparg(ptxt)
      EXITM <eax>
    ENDM

    arrget$ MACRO arr,indx
      push esi
      push edi
      mov esi, arr
      mov edi, indx
      mov esi, [esi+edi*4]
      mov eax, esi
      pop edi
      pop esi
      EXITM <eax>
    ENDM

    create_string_array PROTO :DWORD
    delete_string_array PROTO :DWORD
    write2_string_array PROTO :DWORD,:DWORD,:DWORD

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL hArr  :DWORD
    LOCAL acnt  :DWORD
    LOCAL setv  :DWORD
    LOCAL getv  :DWORD

    push ebx
    push esi
    push edi

    mov acnt, 1000

    mov hArr, dim$(acnt)                    ; create empty array

    mov ecx, hArr
    mov edx, DWORD PTR [ecx]

    mov ebx, 1
  @@:
    mov setv, arrset$(hArr,ebx,str$(ebx))   ; write data to array members
    add ebx, 1
    cmp ebx, acnt
    jle @B

    mov ebx, 1
  @@:
    mov getv, arrget$(hArr,ebx)             ; read data from array members
    print getv,13,10
    add ebx, 1
    cmp ebx, acnt
    jle @B

    mov acnt, erase$(hArr)                  ; delete the array

  ; ===========================================

    print "Accuracy test complete",13,10

  ; ===========================================

    inkey
    cls
    print "Benchmarking array methods on 5 million members",13,10

  ; ===========================================

    mov acnt, 5000000

  ; ------------
  ; create array
  ; ------------
    invoke GetTickCount
    push eax

    mov hArr, dim$(acnt)

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    print str$(eax)," ms array create",13,10

  ; --------------------
  ; load array with data
  ; --------------------
    invoke GetTickCount
    push eax

    mov ebx, 1
  @@:
    mov setv, arrset$(hArr,ebx,str$(ebx))
    add ebx, 1
    cmp ebx, acnt
    jle @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    print str$(eax)," ms array load data",13,10

  ; ---------------------------
  ; get data address from array
  ; ---------------------------
    invoke GetTickCount
    push eax

    mov ebx, 1
  @@:
    mov getv, arrget$(hArr,ebx)
    ;;; print getv,13,10
    add ebx, 1
    cmp ebx, acnt
    jle @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    print str$(eax)," ms array read",13,10

  ; ----------------
  ; delete the array
  ; ----------------
    invoke GetTickCount
    push eax

    mov acnt, erase$(hArr)

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    print str$(eax)," ms array delete",13,10

    pop edi
    pop esi
    pop ebx

    ret

main endp

; 

create_string_array proc mcount:DWORD

    push ebx
    push esi
    push edi

    mov eax, mcount                         ; member count in EAX
    add eax, 1                              ; increment member count
    lea eax, [0+eax*4]                      ; mul by 4 for memory size
    mov esi, alloc(eax)                     ; allocate GlobalAlloc() memory for pointer array

    mov eax, mcount
    mov [esi], eax                          ; store the member count in the first array member

    mov ebx, 1                              ; use EBX as 1 based index
  lbl0:
    invoke SysAllocStringByteLen,0,4        ; allocate 4 byte string
    mov DWORD PTR [eax], 0                  ; set it to a zero length string
    mov [esi+ebx*4], eax                    ; write its address to the pointer array
    add ebx, 1                              ; increment index
    cmp ebx, mcount                         ; check if it matches the member count
    jle lbl0                                ; loop back if not

    mov eax, esi                            ; return pointer array address in EAX

    pop edi
    pop esi
    pop ebx

    ret

create_string_array endp

; 

delete_string_array proc arr:DWORD

    LOCAL mcnt  :DWORD

    push ebx
    push esi
    push edi

    mov esi, arr                            ; load array adress in ESI
    mov eax, [esi]                          ; write member count to EAX
    mov mcnt, eax                           ; store count in local mcnt
    mov ebx, 1                              ; use EBX as 1 based index

  @@:
    invoke SysFreeString,[esi+ebx*4]        ; deallocate each array member
    add ebx, 1
    cmp ebx, mcnt
    jle @B

    free arr                                ; deallocate pointer array

    mov eax, ebx
    sub eax, 1

    pop edi
    pop esi
    pop ebx

    ret

delete_string_array endp

; 

write2_string_array proc arr:DWORD,indx:DWORD,ptxt:DWORD

  ; ----------------------------------------
  ; 4 possible return values
  ; ------------------------
  ; 1. The written text length.
  ; 2. 0 if text length or argument is zero.
  ; 3. -1 bounds error, below 1.
  ; 4. -2 bounds error, above index.
  ; ----------------------------------------

    LOCAL mcnt  :DWORD
    LOCAL tlen  :DWORD

    push ebx
    push esi
    push edi

    mov esi, arr                                ; load array adress in ESI
    mov eax, [esi]                              ; write member count to EAX
    mov mcnt, eax                               ; store count in local mcnt
    mov ebx, indx                               ; store the index in EBX

  ; ---------------------
  ; array bounds checking.
  ; ---------------------
    .if ebx < 1
      mov eax, -1
      jmp quit
    .endif

    .if ebx > mcnt
      mov eax, -2
      jmp quit
    .endif

    invoke SysFreeString,[esi+ebx*4]            ; deallocate the array member

    .if ptxt == 0
    zero_string:
      invoke SysAllocStringByteLen,0,4          ; allocate a buffer of that length
      mov DWORD PTR [eax], 0                    ; set the 4 bytes to zero
      mov [esi+ebx*4], eax
      xor eax, eax
      jmp quit
    .else
      mov tlen, len(ptxt)
      .if tlen == 0
        jmp zero_string
      .endif
      invoke SysAllocStringByteLen,0,tlen       ; allocate a buffer of that length
      mov [esi+ebx*4], eax
      invoke szCopy,ptxt,[esi+ebx*4]
      mov eax, tlen
    .endif

  quit:
    pop edi
    pop esi
    pop ebx

    ret

write2_string_array endp

; 

end start
